#ifdef GL_ES
precision mediump float;
#endif

varying vec4 v_fragmentColor; 
varying vec2 v_texCoord;

vec3 rgb2hsv(vec3 c)
{
    vec4 K = vec4(0.0, -1.0 / 3.0, 2.0 / 3.0, -1.0);
    vec4 p = mix(vec4(c.bg, K.wz), vec4(c.gb, K.xy), step(c.b, c.g));
    vec4 q = mix(vec4(p.xyw, c.r), vec4(c.r, p.yzx), step(p.x, c.r));

    float d = q.x - min(q.w, q.y);
    float e = 1.0e-10;
    return vec3(abs(q.z + (q.w - q.y) / (6.0 * d + e)), d / (q.x + e), q.x);
}

vec3 hsv2rgb(vec3 c)
{
    vec4 K = vec4(1.0, 2.0 / 3.0, 1.0 / 3.0, 3.0);
    vec3 p = abs(fract(c.xxx + K.xyz) * 6.0 - K.www);
    return c.z * mix(K.xxx, clamp(p - K.xxx, 0.0, 1.0), c.y);
}

void main(void) 
{
	gl_FragColor = v_fragmentColor * texture2D(CC_Texture0, v_texCoord);
 	vec3 hsv = rgb2hsv(vec3(gl_FragColor.r, gl_FragColor.g, gl_FragColor.b));
 	// 120:green
 	// 240:blue
 	// 0: red
 	// 45:yellow
 	hsv.r = 180.0 / 360.0; 
 	vec3 rgb = hsv2rgb(hsv);
 	gl_FragColor.r = rgb.r;
 	gl_FragColor.g = rgb.g;
 	gl_FragColor.b = rgb.b;
}